<template>
  <GenericLayout>
    <template #header>
      <Header
        back-button
        :title="pageTitle"
        :badge-content="pageSubTitle"
      />
    </template>

    <template #page-content>
      <template v-if="isDesktopPlatform">
        <div
          class="page-title"
          v-if="pageTitle"
        >
          {{ pageTitle }}
        </div>
        <div
          class="page-subtitle"
          v-if="pageSubTitle"
        >
          {{ pageSubTitle }}
        </div>
      </template>

      <template v-if="loading">
        <div
          class="column flex-center"
        >
          <q-spinner-dots
            color="primary"
            size="40px"
          />
        </div>
      </template>

      <template v-else-if="ready">
        <q-form @submit="onSave">
          <q-card
            :square="!isDesktopPlatform"
            class="column no-wrap col"
          >
            <SoilSiteMap
              :map-style="'height: 350px;'"
              :marker-latitude="latitude"
              :marker-longitude="longitude"
              :use-locate-position="useLocatePosition"
              @mark-location="onMarkLocation"
              @locate-position="onLocatePosition"
            />

            <q-card-section
              class="q-py-xs"
            >
              <q-banner
                dense
                class="text-body2 q-mt-sm bg-grey-3 soil-sample-location-banner"
                :class="{ 'text-negative': missingGeometry }"
              >
                <template #avatar>
                  <q-icon
                    name="las la-info-circle"
                    size="xs"
                  />
                </template>

                <div
                  class="text-small"
                  :class="{ 'row justify-between items-center': isDesktopPlatform, 'column items-start': !isDesktopPlatform}"
                >
                  <div v-if="isContextMenuSupported">
                    <translate v-if="isDesktopPlatform">
                      Set the location with a right click on the map.
                    </translate>
                    <translate v-else>
                      Set the location with a long press on the map.
                    </translate>
                  </div>
                  <div>
                    <q-btn
                      flat
                      size="sm"
                      padding="0"
                      color="primary"
                      @click="onClickSetLocationToLocatePosition"
                    >
                      <translate>Set to my position</translate>
                    </q-btn>
                  </div>
                </div>
              </q-banner>
            </q-card-section>

            <q-card-section>
              <DateTimeSelectorInput v-model="validFrom" />

              <q-input
                v-model="label"
                :placeholder="$gettext('Type a label (optional)')"
                filled
              />
            </q-card-section>

            <q-separator />

            <ObservationsCard
              :initial-observations="observations"
              @on-update="onUpdateObservations"
            />

            <q-separator />

            <q-card-section>
              <div class="row justify-end items-center">
                <q-btn
                  :label="$gettext('Cancel')"
                  flat
                  @click="onCancel"
                />
                <q-btn
                  :label="$gettext('Save')"
                  color="primary"
                  type="submit"
                />
              </div>
            </q-card-section>
          </q-card>
        </q-form>

        <template v-if="soilSite">
          <div class="row justify-end q-mt-lg">
            <q-btn
              flat
              text-color="red"
              :disable="!soilSite"
              :loading="deleting"
              @click="onDelete"
            >
              <translate>Delete this soil sample</translate>
            </q-btn>
          </div>
        </template>
      </template>

      <template v-else-if="!isNew">
        <q-card :square="!isDesktopPlatform">
          <q-card-section>
            <span class="text-subtitle1 text-dark">
              <translate>No soil sample found</translate>
            </span>
          </q-card-section>
        </q-card>
      </template>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import SoilSiteMap from 'src/pages/holding-campaign/soil-site/components/SoilSiteMap'
import ObservationsCard from 'src/pages/holding-campaign/soil-site/components/ObservationsCard'
import DateTimeSelectorInput from 'src/components/form/DateTimeSelectorInput'
import querySoilSiteByPk from 'src/pages/holding-campaign/soil-site/graphql/querySoilSiteByPk'
import queryPlotGeometry from 'src/pages/holding-campaign/graphql/queryPlotGeometry'
import mutationDeleteSoilSite from 'src/pages/holding-campaign/soil-site/graphql/mutationDeleteSoilSite'
import mutationUpdateSoilSite from 'src/pages/holding-campaign/soil-site/graphql/mutationUpdateSoilSite'
import mutationInsertSoilSite from 'src/pages/holding-campaign/soil-site/graphql/mutationInsertSoilSite'

export default {
  name: 'SoilSiteEditPage',
  mixins: [
    PlatformMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    SoilSiteMap,
    ObservationsCard,
    DateTimeSelectorInput
  },
  data () {
    return {
      deleting: false,
      geometry: null,
      validFrom: new Date(),
      label: null,
      observations: [],
      markerDrawn: false,
      missingGeometry: false,
      forceUseLocatePosition: false,
      ignoreUnsaveChanges: false
    }
  },
  computed: {
    pageTitle () {
      return this.soilSiteName
    },
    pageSubTitle () {
      return this.holding?.name || ''
    },
    loading () {
      return !this.isNew && !this.soilSite && this.$apollo.queries.soilSite.loading
    },
    ready () {
      return this.soilSite || (this.isNew && (!this.hasPlotTarget || this.plot))
    },
    holding () {
      return this.$store.state.fastplatform?.holdingCampaign?.holding
    },
    soilSiteId () {
      const soilSiteId = Number(this.$route.params.soilSiteId)
      return isNaN(soilSiteId) ? null : soilSiteId
    },
    plotId () {
      const plotIdParam = this.$route.params.plotId ?? null
      return plotIdParam !== null ? Number(plotIdParam) : null
    },
    isNew () {
      return !this.soilSiteId
    },
    hasPlotTarget () {
      return this.isNew && this.plotId !== null
    },
    targetCentroid () {
      return this.plot?.centroid
    },
    soilSiteName () {
      if (this.isNew) {
        return this.$gettext('New soil sample')
      } else if (this.soilSite) {
        return this.soilSite.label || `${this.$gettext('Soil sample')}`
      } else {
        return '...'
      }
    },
    latitude () {
      const geometry = this.geometry || this.targetCentroid
      return geometry?.coordinates?.[1]
    },
    longitude () {
      const geometry = this.geometry || this.targetCentroid
      return geometry?.coordinates?.[0]
    },
    useLocatePosition () {
      return (this.isNew && !this.hasPlotTarget && !this.markerDrawn) || this.forceUseLocatePosition
    },
    observationsForInsert () {
      return this.getObservationsForMutation()
    },
    observationsForUpdate () {
      return this.getObservationsForMutation(true)
    },
    hasUnsavedChanges () {
      if (this.isNew) {
        return this.geometry || this.label || this.observations.length
      } else {
        if (this.soilSite.geometry !== this.geometry) {
          return true
        }
        if (this.soilSite.validFrom !== this.validFrom) {
          return true
        }
        if (this.soilSite.label !== this.label) {
          return true
        }
        if (this.soilSite.observations.length !== this.observations.length) {
          return true
        }
        for (let i = 0; i < this.soilSite.observations.length; i++) {
          if (this.soilSite.observations[i].observableProperty.id !== this.observations[i].observableProperty.id) {
            return true
          }
          if (this.soilSite.observations[i].result.value !== this.observations[i].result.value) {
            return true
          }
        }
        return false
      }
    },
    isContextMenuSupported () {
      // WebView and Safari mobile do not support context menu (Leaflet 1.7.1 tap emulation is bugged)
      return !this.$q.platform.is.ios
    }
  },
  apollo: {
    soilSite: {
      query: querySoilSiteByPk,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          id: this.soilSiteId
        }
      },
      result ({ data }) {
        if (data?.soilSite) {
          const { geometry, validFrom, label, observations } = data.soilSite
          this.geometry = geometry
          this.validFrom = validFrom
          this.label = label
          this.observations = observations.slice()
        }
      },
      skip () {
        return this.isNew
      }
    },
    plot: {
      query: queryPlotGeometry,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.plotId
        }
      },
      skip () {
        return !this.hasPlotTarget
      }
    }
  },
  beforeRouteLeave (to, from, next) {
    if (this.hasUnsavedChanges && !this.ignoreUnsaveChanges) {
      this.$q.dialog({
        title: this.$gettext('Unsaved changes'),
        message: this.$gettext('Do you really want to leave this page? You have unsaved changes.'),
        cancel: true
      }).onOk(() => {
        next()
      }).onCancel(() => {
        next(false)
      })
    } else {
      next()
    }
  },
  methods: {
    onSave () {
      if (this.isNew) {
        this.onCreate()
      } else {
        this.onUpdate()
      }
    },
    onCreate () {
      const targetGeometry = this.geometry || this.targetCentroid
      if (!targetGeometry) {
        this.missingGeometry = true
        return
      }
      this.$apollo.mutate({
        mutation: mutationInsertSoilSite,
        variables: {
          holdingId: this.holding?.id,
          geometry: targetGeometry,
          validFrom: this.validFrom,
          validTo: this.validFrom,
          label: this.label,
          observations: this.observationsForInsert
        }
      }).then(() => {
        this.$q.notify({
          timeout: 10000,
          message: this.$gettext('The soil sample was sucessfully created.'),
          html: true,
          color: 'green'
        })
        this.ignoreUnsaveChanges = true
        this.$router.back()
      }).catch(e => {
        console.error('Could not create soil sample', e)
        this.$q.notify({
          message: this.$gettext('There was an error while creating the soil sample.'),
          color: 'red'
        })
      })
    },
    onUpdate () {
      this.$apollo.mutate({
        mutation: mutationUpdateSoilSite,
        variables: {
          soilSiteId: this.soilSiteId,
          geometry: this.geometry,
          validFrom: this.validFrom,
          validTo: this.validFrom,
          label: this.label,
          observations: this.observationsForUpdate
        }
      }).then(() => {
        this.$q.notify({
          timeout: 10000,
          message: this.$gettext('The soil sample was sucessfully updated.'),
          html: true,
          color: 'green'
        })
        this.ignoreUnsaveChanges = true
        this.$router.back()
      }).catch(e => {
        console.error('Could not update soil sample', e)
        this.$q.notify({
          message: this.$gettext('There was an error while updating the soil sample.'),
          color: 'red'
        })
      })
    },
    onCancel () {
      this.$router.back()
    },
    onDelete () {
      this.$q.dialog({
        title: this.$gettext('Delete'),
        message: `${this.$gettext('Are you sure you want to delete this soil sample?')}`,
        cancel: true,
        color: 'red'
      }).onOk(async () => {
        this.deleting = true
        try {
          await this.$apollo.mutate({
            mutation: mutationDeleteSoilSite,
            variables: {
              soilSiteId: this.soilSiteId
            }
          })
          this.$q.notify({
            timeout: 10000,
            message: `${this.$gettext('The soil sample was sucessfully deleted.')}<br/>${this.$gettext('We are currently updating the soil properties estimate. Result will be up to date in a few seconds.')}`,
            html: true,
            color: 'green'
          })
        } catch (e) {
          this.$q.notify({
            message: this.$gettext('There was an error while deleting the soil sample.'),
            color: 'red'
          })
        } finally {
          this.deleting = false
          this.ignoreUnsaveChanges = true
          this.$router.back()
        }
      })
    },
    onUpdateObservations (updatedObservations) {
      this.observations = updatedObservations
    },
    getObservationsForMutation (update = false) {
      return this.observations.map(({ observableProperty, result }) => {
        const observationObject = {
          phenomenon_time: this.validFrom,
          observed_property_id: observableProperty.id,
          result
        }
        if (update) {
          observationObject.soil_site_id = this.soilSiteId
        }
        return observationObject
      })
    },
    onMarkLocation (geometry) {
      this.geometry = geometry
      this.missingGeometry = false
      this.markerDrawn = true
    },
    onLocatePosition (geometry) {
      this.locateOnError = false
      if (this.useLocatePosition) {
        this.geometry = geometry
        this.missingGeometry = false
        this.forceUseLocatePosition = false
      }
    },
    onClickSetLocationToLocatePosition () {
      this.forceUseLocatePosition = true
    }
  }
}
</script>
